------------------------------------------------------------------------------
--                             Templates Parser                             --
--                                                                          --
--                            Copyright (C) 2005                            --
--                                  AdaCore                                 --
--                                                                          --
--  This library is free software; you can redistribute it and/or modify    --
--  it under the terms of the GNU General Public License as published by    --
--  the Free Software Foundation; either version 2 of the License, or (at   --
--  your option) any later version.                                         --
--                                                                          --
--  This library is distributed in the hope that it will be useful, but     --
--  WITHOUT ANY WARRANTY; without even the implied warranty of              --
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       --
--  General Public License for more details.                                --
--                                                                          --
--  You should have received a copy of the GNU General Public License       --
--  along with this library; if not, write to the Free Software Foundation, --
--  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.          --
--                                                                          --
--  As a special exception, if other files instantiate generics from this   --
--  unit, or you link this unit with other files to produce an executable,  --
--  this  unit  does not  by itself cause  the resulting executable to be   --
--  covered by the GNU General Public License. This exception does not      --
--  however invalidate any other reasons why the executable file  might be  --
--  covered by the  GNU Public License.                                     --
------------------------------------------------------------------------------

--  $Id: test_tag.adb,v 1.1 2005/02/16 10:40:20 obry Exp $

with Ada.Text_IO;
with Templates_Parser.Debug;

procedure Test_Tag is
   use Ada;
   use Templates_Parser;

   T1, T2 : Tag;
begin
   T1 := +"1" & "2";
   T2 := T1;
   T1 := T1 & "3";
   Text_IO.Put_Line ("T1'Length = " & Natural'Image (Size (T1)));
   Text_IO.Put_Line ("T2'Length = " & Natural'Image (Size (T2)));

   Text_IO.Put ("T1 = ");
   Debug.Print (T1);
   Text_IO.New_Line;

   Text_IO.Put ("T2 = ");
   Debug.Print (T2);
   Text_IO.New_Line;
end Test_Tag;
