------------------------------------------------------------------------------
--                             Templates Parser                             --
--                                                                          --
--                         Copyright (C) 2003 - 2005                        --
--                                 AdaCore                                  --
--                                                                          --
--  This library is free software; you can redistribute it and/or modify    --
--  it under the terms of the GNU General Public License as published by    --
--  the Free Software Foundation; either version 2 of the License, or (at   --
--  your option) any later version.                                         --
--                                                                          --
--  This library is distributed in the hope that it will be useful, but     --
--  WITHOUT ANY WARRANTY; without even the implied warranty of              --
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       --
--  General Public License for more details.                                --
--                                                                          --
--  You should have received a copy of the GNU General Public License       --
--  along with this library; if not, write to the Free Software Foundation, --
--  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.          --
--                                                                          --
--  As a special exception, if other files instantiate generics from this   --
--  unit, or you link this unit with other files to produce an executable,  --
--  this  unit  does not  by itself cause  the resulting executable to be   --
--  covered by the GNU General Public License. This exception does not      --
--  however invalidate any other reasons why the executable file  might be  --
--  covered by the  GNU Public License.                                     --
------------------------------------------------------------------------------

--  $Id: templates_parser-query.ads,v 1.3 2005/02/12 11:51:02 obry Exp $

package Templates_Parser.Query is

   function Kind
     (Association : in Templates_Parser.Association)
      return Association_Kind;
   --  Returns the kind for this association

   function Variable
     (Association : in Templates_Parser.Association)
      return String;
   --  Returns the variable name for Association

   function Composite
     (Association : in Templates_Parser.Association)
      return Tag;
   --  Returns the vector tag for this association, raises Constraint_Error
   --  if it is not a vector.

   function Nested_Level (T : in Tag) return Positive;
   --  Returns the nested level for tag T, 1 means that this is a vector tag,
   --  2 that it is a matrix.

end Templates_Parser.Query;
